#include <Arduino.h>
#include <ESP8266WiFi.h>
//#include <ESP8266mDNS.h>
#include <ESP8266WebServer.h>
#include <ESP8266WebServerSecure.h>
#include <ESP8266HTTPClient.h>
#include <WiFiClientSecureBearSSL.h>
//#include <SPIFFS.h>
#include "LittleFS.h"
#include "ESPTelnet.h"

//user-settings----------------------------------------------------------
#define ssid        "SSID"
#define password    "PASSWORD"
#define lg_url      "https://ru.lgtvsdp.com"
//------------------------------------------------------------------------
#define ledPin      2
#define dname       "lgemu"
//void secureRedirect(void);
bool connectToWifi(void);
String uint64ToString(int64_t);
//void server_sendjson_fixtime_SSL(void);
//void server_sendjson_fixtime_plain(void);
void collect_tv_headers(bool);
void LG_response(bool);
void setupTelnet(void);
void onTelnetConnect(String);
size_t server_sendjson(bool);
void HTTPrequest(void);

char * deviceSecret = "12345678890qwertyuiop12345678890qwertyuiop12345678890qwertyuiop12345678890qwertyuiop12345678890qwertyuiop12345678890qwertyuiop12345678890qwertyuiop123==";
char * sessionID = "12345678890qwertyuiop123456=";

//const char *ssid = "Gdetonet";
//const char *password = "xf4edby3n";
//const char *dname = "lgemu";
bool noresponse = false;
bool triggerHTTPrequest = false;
bool timetoggle = true;


const char * tv_headerKeys[] = {"X-Device-Language","X-Device-FW-Version","X-Device-ContentsQA-Flag","X-Device-Netcast-Platform-Version","X-Device-Country-Group","X-Device-Type","X-Device-FCK","X-Device-SDK-VERSION","X-Device-Locale","X-Device-Remote-Flag","X-Device-Country","X-Device-Eula","X-Device-Model","X-Device-ID","X-Device-Eco-Info","X-Device-Product","X-Device-Platform","X-Device-Publish-Flag","X-Device-Sales-Model"} ;
//const char * lg_headerKeys[] = {"Date","Server","X-Server-Time","Set-Cookie","Connection","Transfer-Encoding","Content-Type"};
const char * lg_headerKeys[] = {"Set-Cookie"};
size_t tv_headerkeyssize = sizeof(tv_headerKeys)/sizeof(char*);
size_t lg_headerkeyssize = sizeof(lg_headerKeys)/sizeof(char*);
std::vector<String> tv_headers;
std::vector<String> tv_header_names;
std::vector<String> tv_params;
std::vector<String> tv_param_names;
String lg_cookie="JSESSIONID=1F02541CF642EE1205BCC61B94A46BDE.node_sdp02_new; Path=/rest/; Secure; HttpOnly";
size_t tv_paramssize; 
String tv_uri="";


BearSSL::ESP8266WebServerSecure server(443);
ESP8266WebServer serverHTTP(80);
ESPTelnet telnet;
IPAddress ip;

static const char serverCert[] PROGMEM = R"EOF(
-----BEGIN CERTIFICATE-----
MIIDMzCCApygAwIBAgIUb/Igm78Z2l+p8QuwbWiFlwjOvSEwDQYJKoZIhvcNAQEL
BQAwgYwxCzAJBgNVBAYTAktSMRQwEgYDVQQIDAtTb3V0aCBLb3JlYTEOMAwGA1UE
BwwFU2VvdWwxHDAaBgNVBAoME0xHIEVsZWN0cm9uaWNzIEluYy4xITAfBgNVBAsM
GERpZ2l0YWwgVFYgUmVzZWFyY2ggTGFiLjEWMBQGA1UEAwwNKi5sZ3R2c2RwLmNv
bTAgFw0yMTA2MTcyMjMyMzhaGA8yMDUxMDYxMDIyMzIzOFowgYwxCzAJBgNVBAYT
AktSMRQwEgYDVQQIDAtTb3V0aCBLb3JlYTEOMAwGA1UEBwwFU2VvdWwxHDAaBgNV
BAoME0xHIEVsZWN0cm9uaWNzIEluYy4xITAfBgNVBAsMGERpZ2l0YWwgVFYgUmVz
ZWFyY2ggTGFiLjEWMBQGA1UEAwwNKi5sZ3R2c2RwLmNvbTCBnzANBgkqhkiG9w0B
AQEFAAOBjQAwgYkCgYEAuRVwEoldMVU4S3NOUR/CoEkBM3SYIsG/mIa1s9HKpUj9
sdJrnStw1yxmd41ZmiND0p94MqG6nx7PcuaTSRYpwO+GZJfLaT2L0F7gDy9qjFNY
Uo87upZb/eN5x2qIr2P2jKC/ty64zAnUORSsyfV5AfcapDpF/I4VlMnI+zTP41sC
AwEAAaOBjTCBijAdBgNVHQ4EFgQUcVvmY7pxAGxPBFoQaY8mtOjU9GowHwYDVR0j
BBgwFoAUcVvmY7pxAGxPBFoQaY8mtOjU9GowDwYDVR0TAQH/BAUwAwEB/zA3BgNV
HREEMDAuggkqLmxnZS5jb22CDyoubGdzbWFydGFkLmNvbYIQKi4qLmxnYXBwc3R2
LmNvbTANBgkqhkiG9w0BAQsFAAOBgQAFiaJMk9KoHZjbJyPM4IMTDS/jxiCK1pDY
jJl4VRIJ75EKACDllGeZxfU6Y9LB4ebjGJTp8n+gz3c2MJ7YnfGch9BmJeLAI8WA
7bsLWJ8BeBjmpa6l4vqGpMuH8nF5vPOkNIzWbzTJYlkz8h+GNKwjXy5/2GBtQ6CR
QHfvfwcEgg==
-----END CERTIFICATE-----
)EOF";


static const char serverKey[] PROGMEM =  R"EOF(
-----BEGIN PRIVATE KEY-----
MIICdwIBADANBgkqhkiG9w0BAQEFAASCAmEwggJdAgEAAoGBALkVcBKJXTFVOEtz
TlEfwqBJATN0mCLBv5iGtbPRyqVI/bHSa50rcNcsZneNWZojQ9KfeDKhup8ez3Lm
k0kWKcDvhmSXy2k9i9Be4A8vaoxTWFKPO7qWW/3jecdqiK9j9oygv7cuuMwJ1DkU
rMn1eQH3GqQ6RfyOFZTJyPs0z+NbAgMBAAECgYEApltogqDJDQCGOvsHF8+uRheY
ZsGTxRnUtqnORDR7KpkyvlRducVEBYO5DhgUw4CTA4umpAvODBvLZoFtPTIYj/S/
cbivUkwB90yJjP/PzqPnY/aAQF7vFmA2vrYY+RmckpvtuWTYKg9kJXkrbA1x2gEY
0fhYpsLfnWiIdVvUrZECQQDgXlS6IbvYF2IcjkJ8zoVSqRCdaRnK1qB4sqYGlcPC
WxNuqjREFojytIDu7fa9JbG8fmI88EuqnmxK3/1hZtkXAkEA0y1Ioa0SUeNtnRoR
2AY0YA0RpQnRPO8hQWHvshb1zo3aNiRDrCRAvtcaqdb3M0sVqwbXQfrfw/tpXuzB
apzqXQJAWlZAwOyiKEBJ9Xtl08CHN5/wm6BcjSnbVJ2BcXdNaWyoJ0+KWbvFCguZ
Oho/1SpfJKiyPxz1Kk49BeynpVb2owJBAMOajkwzI2T2Y/HA1AZkuN6/PDjCfy0R
0pvdO0iaO9S3UAgWTxiD+/TJCcmHdDHuuoNQMtLKrbm6hj+GzSETd4ECQA7BAUoA
kvShJDz5J9l3wftRPbVupl+jtrSxAPAhc6UFEebmeHkKB1IcyHIL+ihnz1jo8e9T
pNd8hkQpqG/9Mbk=
-----END PRIVATE KEY-----
)EOF";



void setup() {
  //  pinMode(D0, OUTPUT);
  pinMode(ledPin, OUTPUT);
  digitalWrite(ledPin, HIGH);
  Serial.begin(115200);

  // Initialize SPIFFS
  /*if(!SPIFFS.begin()){
    Serial.println("An Error has occurred while mounting SPIFFS");
    return;
  }*/
  if (LittleFS.begin()){
        Serial.println(F("done."));
    }else{
        Serial.println(F("fail."));
    }

  if (!connectToWifi()) {
    delay(6000);
    ESP.restart();
  } else {
    ip = WiFi.localIP();
    setupTelnet();
    Serial.println("Telnet started");
    digitalWrite(ledPin, LOW);    
  }
  configTime(3 * 3600, 0, "pool.ntp.org", "time.nist.gov");

  
  serverHTTP.onNotFound([](){
    collect_tv_headers(false);
    LG_response(false);
    triggerHTTPrequest = true;
    });

  serverHTTP.on("/test_client",[](){
  HTTPrequest();
  });
  serverHTTP.collectHeaders(tv_headerKeys, tv_headerkeyssize );
  serverHTTP.begin();
  server.getServer().setRSACert(new BearSSL::X509List(serverCert), new BearSSL::PrivateKey(serverKey));

  server.onNotFound([](){
    collect_tv_headers(true);
    triggerHTTPrequest = true;
    LG_response(true);
    });
  server.collectHeaders(tv_headerKeys, tv_headerkeyssize );
  server.begin();
  
  Serial.println("Server is ready");
}
  
void loop() {
  if (triggerHTTPrequest) {
    HTTPrequest();
  }
  serverHTTP.handleClient();
  server.handleClient();
  telnet.loop();
  if (Serial.available()) {
    telnet.print(Serial.read());
  }
  delay(50);
}

bool connectToWifi() {
  byte timeout = 10;

  Serial.println("\n\n");

  Serial.print("Connecting to ");
  Serial.println(ssid);

  WiFi.begin(ssid, password);

  for (int i = 0; i < timeout; i++) {
    if (WiFi.status() == WL_CONNECTED) {
      Serial.println("\nConnected to WiFi");
      Serial.print("Server can be accessed at https://");
      Serial.print(WiFi.localIP());
    return true;
    }
    digitalWrite(ledPin, HIGH);
    delay(2500);
    digitalWrite(ledPin, LOW);
    delay(2500);
    digitalWrite(ledPin, HIGH);
    Serial.print(".");
  }

  Serial.println("\nFailed to connect to WiFi");
  Serial.println("Check network status and access data");
  Serial.println("Push RST to try again");
  return false;
}


String uint64ToString(int64_t input) {
  String result = "";
  int64_t base = 10;

  do {
    char c = input % base;
    input /= base;

    if (c < 10)
      c +='0';
    else
      c += 'A' - 10;
    result = c + result;
  } while (input);
  return result;
}



void LG_response(bool SSL)
{
  String content = "<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"yes\"?>";
    content += "<error>";
    (SSL) ? content += "<request>" + server.uri() + "</request>" : content += "<request>" + serverHTTP.uri() + "</request>" ;
    content += "<code>TBD</code>";
    content += "<message>Precondition Failed</message>";
    content += "</error>";
  struct timeval tv_now;
  gettimeofday(&tv_now, NULL);
  String time_ms = uint64ToString((int64_t)tv_now.tv_sec * 1000LL + (int64_t)tv_now.tv_usec / 1000LL);
  if (tv_uri.indexOf("initservices") > 0) {
    (SSL) ? server.sendHeader("Server","Apache") : serverHTTP.sendHeader("Server","Apache");
    File file = LittleFS.open("/initservices.json", "r");
   if (file) {
    (SSL) ? server.sendHeader("x-server-time",time_ms) : serverHTTP.sendHeader("x-server-time",time_ms);
    (SSL) ? server.sendHeader("Set-Cookie",lg_cookie) : serverHTTP.sendHeader("Set-Cookie",lg_cookie);
    //(SSL) ? server.sendHeader("Connection","close") : serverHTTP.sendHeader("Connection","close");
    server_sendjson(SSL);
    Serial.println("JSON is sent");
    telnet.println("JSON time is sent\r");
   } else {
    (SSL) ? server.sendHeader("x-server-time",time_ms) : serverHTTP.sendHeader("x-server-time",time_ms);
    (SSL) ? server.send(200, "text/xml;charset=UTF-8", content) : serverHTTP.send(200, "text/xml;charset=UTF-8", content);
    Serial.println("No JSON found on FS");
    telnet.println("No JSON found on FS\r");
   }
    file.close();
   } else {
    (SSL) ? server.sendHeader("x-server-time",time_ms) : serverHTTP.sendHeader("x-server-time",time_ms);
    (SSL) ? server.sendHeader("Server","Apache") : serverHTTP.sendHeader("Server","Apache");
    (SSL) ? server.send(200, "text/xml;charset=UTF-8", content) : serverHTTP.send(200, "text/xml;charset=UTF-8", content);
    Serial.println("LG NOTFOUND page sent");
    telnet.println("LG NOTFOUND page sent\r");
   }
}

void collect_tv_headers(bool SSL)
{
String message = "Query received:\r\n";
    (SSL) ? tv_uri=server.uri() : tv_uri=serverHTTP.uri();
    message += "URL:" + tv_uri;
    message += "\r\n query params:\r\n";
    tv_paramssize=0;
    tv_params.clear();
    tv_param_names.clear();
    tv_headers.clear();
    tv_header_names.clear();
    if (SSL) {
      for (uint8_t i = 0; i < server.args(); i++) {
        tv_params.push_back(server.arg(i));
        tv_param_names.push_back(server.argName(i));
        tv_paramssize ++;
        message += " " + server.argName(i) + ": " + server.arg(i) + "\r\n";
      }
      message += " query headers:\r\n";
      for (uint8_t i = 0; i < server.headers(); i++) {
        tv_headers.push_back(server.header(i));
        tv_header_names.push_back(server.headerName(i));
        message += " " + server.headerName(i) + ": " + server.header(i) + "\r\n";
      }
    } else {
      for (uint8_t i = 0; i < serverHTTP.args(); i++) {
        tv_params.push_back(serverHTTP.arg(i));
        tv_param_names.push_back(serverHTTP.argName(i));
        message += " " + serverHTTP.argName(i) + ": " + serverHTTP.arg(i) + "\r\n";
      }
      message += " query headers:\r\n";
        for (uint8_t i = 0; i < serverHTTP.headers(); i++) {
        tv_headers.push_back(serverHTTP.header(i));
        tv_header_names.push_back(serverHTTP.headerName(i));
      message += " " + serverHTTP.headerName(i) + ": " + serverHTTP.header(i) + "\r\n";
      }
    }
    Serial.println(message);
    telnet.println(message);
}

void setupTelnet() {  
  // passing on functions for various telnet events
  telnet.onConnect(onTelnetConnect);
  //telnet.onConnectionAttempt(onTelnetConnectionAttempt);
  //telnet.onReconnect(onTelnetReconnect);
  //telnet.onDisconnect(onTelnetDisconnect);
  
  // passing a lambda function
  telnet.onInputReceived([](String str) {
    // checks for a certain command
    if (str == "ping") {
      telnet.println("> pong\r");
      Serial.println("- Telnet: pong\r");
    }
    if (str == "test_client") {
      HTTPrequest();
    }
  });

  Serial.print("- Telnet: ");
  if (telnet.begin()) {
    Serial.println("running");
  } else {
    Serial.println("error.");
    //errorMsg("Will reboot...");
  }
}

void onTelnetConnect(String ip) {
  Serial.print("- Telnet: ");
  Serial.print(ip);
  Serial.println(" connected");
  telnet.println("\r\nWelcome " + telnet.getIP());
  telnet.println("\r\nfirst input will not work\r");
  telnet.println("test_client for test request to lgtvsdp.com server\r");
  //telnet.println("(Use ^] + q  to disconnect.)\r");
}


size_t server_sendjson(bool SSL)
{
File f=LittleFS.open("/initservices.json", "r");
if(f)
    {
      char buf[512];
      char buf2[512];
      size_t sent = 0;
      int siz = f.size();
      server.chunkedResponseModeStart(200,"application/json;charset=UTF-8");
      Serial.println("\r\nSend file size="+String(siz));
      telnet.println("\r\nSend file size="+String(siz));
      char * psec;
      char * pses;

      while(siz > 0) {
        size_t len = std::min((int)(sizeof(buf) - 1), siz);
        memset(buf, 0, sizeof(buf));
        f.read((uint8_t *)buf, len);
        psec = strstr (buf, "\"deviceSecret\": \"");
        pses = strstr (buf, "\"sessionID\": \"");
        bool replaced = false;
        if ((psec)&&(pses)&&(!replaced)) {
          replaced = true;
          memset(buf2, 0, sizeof(buf));
          size_t startsec = psec-buf+17;
          size_t startses = pses-buf+14;
          size_t endsec = psec-buf+17+strlen(deviceSecret);
          size_t endses = pses-buf+14+strlen(sessionID);

          Serial.print("found [\"deviceSecret\"] at position "); Serial.print((int) (psec-buf));
          telnet.print("\r\nfound [\"deviceSecret\"] at position "); telnet.print((int) (psec-buf)); telnet.print("\r\n");
          strncat(buf2,buf,startsec);
          strcat(buf2,deviceSecret);
          strncat(buf2,buf+endsec,startses-endsec);
          strcat(buf2,sessionID);
          strcat(buf2,buf+endses);
          strcpy(buf,buf2);
        }
        server.sendContent(buf);
        siz -= len;
        sent+=len;
      }
      server.chunkedResponseFinalize();
     f.close();  
     Serial.println(" sended "+String(sent));
     telnet.println(" sended "+String(sent));
     return(sent);  
    }
else {
  (SSL) ? server.send(404, "text/plain", "FileNotFound") : serverHTTP.send(404, "text/plain", "FileNotFound");
  Serial.println("Bad open file");
  telnet.println("Bad open file");
}
return(0);  
}

void HTTPrequest()
{
  if (tv_uri.indexOf("initservices") > 0) {
    delay(1000);
    std::unique_ptr<BearSSL::WiFiClientSecure>client(new BearSSL::WiFiClientSecure);
    client->setInsecure();
    HTTPClient httpsclient;
    httpsclient.collectHeaders(lg_headerKeys, lg_headerkeyssize);
    Serial.print("[HTTPS] begin...\n");
    telnet.print("[HTTPS] begin...\r\n");
    if (httpsclient.begin(*client, lg_url + tv_uri)) {  // HTTPS
      Serial.print("[HTTPS] POST...\n");
      telnet.print("[HTTPS] POST...\r\n");
      // start connection and send HTTP header
        String request_params=tv_param_names[0] + "=" + tv_params[0];
        for (uint8_t i = 1; i < tv_paramssize; i++) {
          request_params += "&" + tv_param_names[i] + "=" + tv_params[i];
        }
        Serial.println("Client request params: " + request_params);
        telnet.print("Client request params: " + request_params + "\r\n");

        httpsclient.addHeader(tv_header_names[0],tv_headers[0],true,true);
        Serial.println("Cleent request Header0: " + tv_header_names[0] + "=" + tv_headers[0]);
        telnet.print("Cleent request Header0: " + tv_header_names[0] + "=" + tv_headers[0] + "\r\n");
        for (uint8_t i = 1; i < tv_headerkeyssize; i++) {
          httpsclient.addHeader(tv_header_names[i],tv_headers[i],false,false);
          Serial.println("Client Header" + String(i) + ": " + tv_header_names[i] + "=" + tv_headers[i]);
          telnet.println("Client Header" + String(i) + ": " + tv_header_names[i] + "=" + tv_headers[i] + "\r\n");
        }
      int httpCode = httpsclient.POST(request_params);
      // httpCode will be negative on error
      if (httpCode > 0) {
        // HTTP header has been send and Server response header has been handled
        Serial.printf("[HTTPS] POST... code: %d\n", httpCode);
        telnet.print("[HTTPS] POST... code: " + String(httpCode) + "\r\n");
        // file found at server
        if (httpCode == HTTP_CODE_OK || httpCode == HTTP_CODE_MOVED_PERMANENTLY) {
          String message="";
          lg_cookie = httpsclient.header("Set-Cookie");
          Serial.println(message);
          telnet.println(message);
          String payload = httpsclient.getString();
          char buf[512];
          memset(buf, 0, sizeof(buf));
          payload.toCharArray(buf,512);
          char * psec = strstr (buf, "deviceSecret");
          char * pses = strstr (buf, "sessionID");
          if ((psec)&&(pses)) {
            size_t startsec = psec-buf+17;
            size_t startses = pses-buf+14;
            size_t endsec = psec-buf+17+strlen(deviceSecret);
            size_t endses = pses-buf+14+strlen(sessionID);
            strncpy(deviceSecret,buf+startsec,endsec-startsec);
            strncpy(sessionID,buf+startses,endses-startses);
            Serial.println("Found deviceSecret in LG response at position: " + String(startsec) + " with and at: " + String(endsec));
            telnet.print("Found deviceSecret in LG response at position: " + String(startsec) + " with and at: " + String(endsec) + "\r\n");
            Serial.println(deviceSecret);
            telnet.println(deviceSecret);
            Serial.println("Found sessionID in LG response at position: " + String(startses) + " with and at :" + String(endses));
            telnet.println("Found sessionID in LG response at position: " + String(startses) + " with and at :" + String(endses) + "\r\n");
            Serial.println(sessionID);
            telnet.println(sessionID);
          }else{
            Serial.println("Not Found deviceSecret and sessionID in LG response");
            telnet.print("Not Found deviceSecret and sessionID in LG response\r\n");
            noresponse = true;
          }

          //Serial.println(payload);
        }
      } else {
        Serial.printf("[HTTPS] POST... failed, error: %s\n", httpsclient.errorToString(httpCode).c_str());
        telnet.print("[HTTPS] POST... failed, error: " + String(httpsclient.errorToString(httpCode).c_str()) + "\r\n");
        noresponse = true;
      }
      httpsclient.end();
    } else {
      Serial.printf("[HTTPS] Unable to connect\n");
      telnet.print("[HTTPS] Unable to connect\r\n");
      noresponse = true;
    }
  }
  triggerHTTPrequest = false;
}
